DECLARE SUB KeyRelease (ButtonNumber AS INTEGER)
DECLARE SUB mreset ()
DECLARE SUB ShowCur ()
DECLARE SUB HideCur ()
DECLARE SUB SetLoc ()
DECLARE SUB ReadLoc ()

'Mouse Routines for QuickBASIC 4.5 (Must load QB.QLB)

'Alan Aslett, (416)-782-9558, Oct. 3, 1990



TYPE RegType
     AX    AS INTEGER
     BX    AS INTEGER
     CX    AS INTEGER
     DX    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
END TYPE

DECLARE SUB interrupt (intnum AS INTEGER, inreg AS RegType, outreg AS RegType)

DEFINT A-Z

DIM SHARED inregs AS RegType
DIM SHARED OutRegs AS RegType

CONST mmouse = 51

CALL mreset
inregs.CX = 320 'x location
inregs.DX = 100 'y location
CALL SetLoc
COLOR 0, 7
CLS
COLOR 15, 7
LOCATE 1, 1
PRINT "                          MOUSE TEST PROGRAMME"
COLOR 0, 7
PRINT ""
PRINT "                      Hit ESC or use Mouse to exit."
LOCATE 10, 1
PRINT "Mouse Status (Left=1, Right=2, Middle=4) :"
PRINT "Mouse X-Position  (Graphics Coordinates) :"
PRINT "Mouse Y-Position  (Graphics Coordinates) :"
PRINT "Mouse X-Position      (Text Coordinates) :"
PRINT "Mouse Y-Position      (Text Coordinates) :"
LOCATE 17, 1
PRINT "# Left   Presses  (X,Y) :"
PRINT "# Middle Presses  (X,Y) :"
PRINT "# Right  Presses  (X,Y) :"
LOCATE 22, 1
COLOR 15, 7
PRINT "                                                              ͻ";
PRINT "                                                              EXIT";
PRINT "                                                              ͼ";
COLOR 0, 7
LeftNumber% = 0
RightNumber% = 0
MiddleNumber% = 0
ShowCur
DO
  TEST$ = INKEY$
  IF TEST$ <> "" THEN
    IF ASC(TEST$) = 27 THEN EXIT DO
  END IF
  ReadLoc
  COLOR 15, 7
  LOCATE 10, 45
  PRINT USING "###"; OutRegs.BX;
  LOCATE 11, 45
  PRINT USING "###"; OutRegs.CX;
  LOCATE 12, 45
  PRINT USING "###"; OutRegs.DX;
  LOCATE 13, 45
  PRINT USING "###"; INT(OutRegs.CX / 7.9) + 1;
  LOCATE 14, 45
  PRINT USING "###"; INT(OutRegs.DX / 7.9) + 1;
  ButtonNumber = 1
  KeyRelease (ButtonNumber)
  LOCATE 17, 27
  'Exit Button Test.
  IF (OutRegs.CX > 495 AND OutRegs.CX < 537) AND (OutRegs.DX > 167 AND OutRegs.DX < 185) THEN EXIT DO
  IF OutRegs.BX >= 1 THEN LeftNumber% = LeftNumber% + 1
  PRINT USING "###"; LeftNumber%;
  PRINT "  (";
  PRINT USING "##"; INT(OutRegs.CX / 7.9) + 1;
  PRINT ",";
  PRINT USING "##"; INT(OutRegs.DX / 7.9) + 1;
  PRINT ")"
  ButtonNumber = 2
  KeyRelease (ButtonNumber)
  LOCATE 19, 27
  IF OutRegs.BX >= 1 THEN RightNumber% = RightNumber% + 1
  PRINT USING "###"; RightNumber%;
  PRINT "  (";
  PRINT USING "##"; INT(OutRegs.CX / 7.9) + 1;
  PRINT ",";
  PRINT USING "##"; INT(OutRegs.DX / 7.9) + 1;
  PRINT ")"
  ButtonNumber = 4
  KeyRelease (ButtonNumber)
  LOCATE 18, 27
  IF OutRegs.BX >= 1 THEN MiddleNumber% = MiddleNumber% + 1
  PRINT USING "###"; MiddleNumber%;
  PRINT "  (";
  PRINT USING "##"; INT(OutRegs.CX / 7.9) + 1;
  PRINT ",";
  PRINT USING "##"; INT(OutRegs.DX / 7.9) + 1;
  PRINT ")"
  COLOR 0, 7
LOOP
HideCur
COLOR 7, 0
CLS
END

DEFSNG A-Z
SUB GraAttrib
  'Defines the graphics cursor attributes.
  inregs.AX = 9    'function call
  inregs.BX = 0    'horizontal hotspot
  inregs.CX = 0    'vertical hotspot
  DIM cursor(8)
  cursor(0) = &HFF
  cursor(1) = &H8F
  cursor(2) = &HF
  cursor(3) = &H8
  inregs.DX = VARPTR(cursor)
  CALL interrupt(mmouse, inregs, OutRegs)
END SUB

SUB HideCur
  'Routine to hide the mouse cursor.
  inregs.AX = 2
  CALL interrupt(mmouse, inregs, OutRegs)
END SUB

SUB keypress (ButtonNumber AS INTEGER)
  'Caller must set ButtonNumber.
  IF ButtonNumber = 1 THEN ButtonNumber = 0
  IF ButtonNumber = 2 THEN ButtonNumber = 1
  IF ButtonNumber = 4 THEN ButtonNumber = 2
  inregs.BX = ButtonNumber
  inregs.AX = 5
  CALL interrupt(mmouse, inregs, OutRegs)
  'outregs.ax = button status
  'outregs.bx = updated press count
  'outregs.cx = x-coordinate at last press
  'outregs.dx = y-coordinate at last press
END SUB

SUB KeyRelease (ButtonNumber AS INTEGER)
  'Caller must set ButtonNumber
  IF ButtonNumber = 1 THEN ButtonNumber = 0
  IF ButtonNumber = 2 THEN ButtonNumber = 1
  IF ButtonNumber = 4 THEN ButtonNumber = 2
  inregs.AX = 6
  inregs.BX = ButtonNumber
  CALL interrupt(mmouse, inregs, OutRegs)
  'outregs.ax = button status
  'outregs.bx = updated release count
  'outregs.cx = x-coordinate last release
  'outregs.dx = y-coordinate last release
END SUB

SUB MotionSens (hor AS INTEGER, ver AS INTEGER)
  'Routine to set the mouse sensitivity.
  inregs.AX = 15 'function number
  inregs.CX = hor 'horizontal sensitivity ratio
  inregs.DX = ver 'vertical; sensitivity ratio
  CALL interrupt(mmouse, inregs, OutRegs)
END SUB

SUB mousemotion
  'Routine to get the mouse motion counters.
  inregs.AX = 11 'set up function
  CALL interrupt(mmouse, inregs, OutRegs) 'call it
  'outregs.cx = horizontal motion units
  'outregs.dx = vertical motion units
END SUB

SUB MouseXLim (xmin AS INTEGER, xmax AS INTEGER)
  'Routine to define the x range of the mouse.
  inregs.AX = 7
  inregs.CX = xmin
  inregs.DX = xmax
  CALL interrupt(mmouse, inregs, OutRegs)
END SUB

SUB MouseYLim (ymin AS INTEGER, ymax AS INTEGER)
  'Subroutine to set the Y limits for the mouse
  inregs.AX = 8     'Function number
  inregs.CX = ymin  'Smallest Y
  inregs.DX = ymax  'Largest Y
  CALL interrupt(mmouse, inregs, OutRegs) 'Execute the interrupt
END SUB

SUB mreset
  'Reset the Mouse Driver.   
  inregs.AX = 0
  CALL interrupt(mmouse, inregs, OutRegs)
END SUB

SUB ReadLoc
  'Routine to read the mouse location and button status.
  inregs.AX = 3
  CALL interrupt(mmouse, inregs, OutRegs)
  'outregs.BX = Button status (L=1,R=2,C=4,add for combo)
  'outregs.CX = X coordinate
  'outregs.DX = Y Coordinate
END SUB

SUB SetLoc
  'Routine to set the cursor location.
  'inregs.CX = New X coordinate, caller must set.
  'inregs.DX = New Y coordinate, caller must set.
  inregs.AX = 4
  CALL interrupt(mmouse, inregs, OutRegs)
END SUB

SUB ShowCur
  'Routine to display the mouse cursor.
  inregs.AX = 1
  CALL interrupt(mmouse, inregs, OutRegs)
END SUB

